import javax.swing.JComponent;
import java.awt.*;
import java.awt.geom.*;
/**
 * A simple graphics component, displaying a box that moves continuously.
 * 
 * Changes since version 14: we now tell each Box what Rectangle to bounce
 * around in.  For the orange and green ones, I use the entire window; for 
 * the blue one, I use a smaller rectangle within the initial window.  For
 * clarity, I also draw this rectangle.
 * 
 * @author Stephen Bloch
 * @version 13, Sept 13 2006
 */
public class MyComponent extends JComponent
{
    // instance variables
    /** @since version 11 */
    private Box theBox;
    /** @since version 13 */
    private Box box2, box3;
    private Rectangle blueBounds;
    private Rectangle currentBounds;
    /**
     * Constructor for objects of class MyComponent
     */
    public MyComponent()
    {
        // initialize instance variables
        this.theBox = new Box(Color.BLUE, 75, 58, 21, 34, 2, 3);
        this.box2 = new Box(Color.ORANGE, 300, 10, 15, 9, -2, 1);
        this.box3 = new Box(Color.GREEN, 400, 600, 5, 20, -2, -3);
        this.blueBounds = new Rectangle (20, 20, 300, 200);
    }

    /**
     * Display a box.
     * 
     * @param  g    a Graphics context into which we are to draw
     */
    public void paintComponent (Graphics g) {
        Graphics2D g2 = (Graphics2D)g;
        
        g2.setColor (Color.BLUE);
        g2.draw (this.blueBounds);
        
        this.theBox.show (g2);
        this.box2.show (g2);
        this.box3.show (g2);
        
        // update the locations
        this.theBox.move (this.blueBounds);
        this.currentBounds = new Rectangle (0, 0, this.getWidth(), this.getHeight());
        this.box2.move (this.currentBounds);
        this.box3.move (this.currentBounds);
        
        for (int wasteTime = 0; wasteTime < 10000000; ++wasteTime) {}
        
        // force another redisplay soon
        this.repaint (this.getVisibleRect());
    }
}
